"""Classes for the services application.
"""

import xmlrpclib
from SOAPpy import SOAPProxy


##from pyPgSQL import PgSQL

CONNECT_ARGS = 'localhost:5432:test:postgres:flicker'


class Services:
    count = -1
    quotes = [
        "1. God reigns in heaven.  Here on earth, one must help oneself.",
        '2. If something can go wrong, it will go wrong.',
        '3. Things never get better.',
        '4. I love work.  I could watch it all day long.',
        '5. Def. Special interests: Someone who does not support me.',
        '6. Garlic is to salad as insanity is to art.',
        '7. Always do good.  It will surprise your friends and confound your enemies.',
        ]
    def __init__(self):
        pass

    def quote_of_the_day(self, direction):
        if direction == 'Forward':
            if Services.count >= len(Services.quotes) - 1:
                Services.count = -1
            Services.count += 1
        else:
            if Services.count <= 0:
                Services.count = len(Services.quotes)
            Services.count -= 1
        quote = Services.quotes[Services.count]
        return quote

    def temperature_convert(self, xmlrpcProxy, command, intemp):
        if command == 'c2f':
            #proxy = xmlrpclib.ServerProxy('http://localhost:8082')
            outtemp = xmlrpcProxy.c2f(intemp)
            return outtemp
        else:
            #proxy = xmlrpclib.ServerProxy('http://localhost:8082')
            outtemp = xmlrpcProxy.f2c(intemp)
            return outtemp

    def structure_convert(self, soapProxy, indict):
##        soapProxy = SOAPProxy(str("http://localhost:8083/"))
        values = soapProxy.structures(indict)
        return values

    def db_query(self, dbConnection, action, sortby, plantName, plantDesc, plantRating):
##        self.con = PgSQL.connect(CONNECT_ARGS)
        #self.con = dbConnection
        cursor = dbConnection.cursor()
        if action == 'View':
            msg = 'Viewing'
            rowSet = self._db_retrieve(cursor, sortby)
        elif action == 'Add':
            cursor.execute("select * from Plant_DB where p_name = '%s'" % plantName)
            row = cursor.fetchone()
            if row:
                msg = 'Plant (%s) already exists.' % plantName
            else:
                sql = "insert into Plant_DB values ('%s', '%s', '%s')" % \
                    (plantName, plantDesc, plantRating)
                cursor.execute(sql)
                dbConnection.commit()
                msg = 'Added'
            rowSet = self._db_retrieve(cursor, sortby)
        elif action == 'Delete':
            sql = "select * from Plant_DB where p_name = '%s'" % plantName
            cursor.execute(sql)
            row = cursor.fetchone()
            if row:
                cursor.execute("delete from Plant_DB where p_name='%s'" % plantName)
                dbConnection.commit()
                msg = 'Plant (%s) deleted.' % plantName
            else:
                msg = 'Plant (%s) does not exist.' % plantName
            rowSet = self._db_retrieve(cursor, sortby)
        elif action == 'Modify':
            cursor.execute("select * from Plant_DB where p_name = '%s'" % plantName)
            row = cursor.fetchone()
            if row:
                sql = "update Plant_DB set p_desc='%s', p_rating='%s' where p_name='%s'" % \
                    (plantDesc, plantRating, plantName)
                cursor.execute(sql)
                dbConnection.commit()
                msg = 'Updated plant (%s).' % plantName
            else:
                msg = 'Plant (%s) does not exist.' % plantName
            rowSet = self._db_retrieve(cursor, sortby)
        else:
            rowSet = None
        cursor.close()
        return (msg, rowSet)

    def _db_retrieve(self, cursor, sortby):
        if sortby == 'Name':
            sql = "select * from Plant_DB order by p_name"
        else:
            sql = "select * from Plant_DB order by p_rating"
        cursor.execute(sql)
        rows = cursor.fetchall()
        return rows

Params = {
    'time_period' : '1WEEK',
    'descriptions' : 1,
    'categories' : 0,
    'channels' : 0,
    'dates' : 0,
#    'num_items': 10,
    }


class Meerkat:

    def channels_by_string(self, meerkatServer, searchString):
        #meerkatURI = "http://www.oreillynet.com/meerkat/xml-rpc/server.php"
        results = meerkatServer.meerkat.getChannelsBySubstring(searchString)
        return results

    def items(self, meerkatServer, ichannel, timePeriodValue):
        results = meerkatServer.meerkat.getChannelsBySubstring('')
        title = '* Unknown *'
        for result in results:
            if result['id'] == ichannel:
                title = result['title']
                break
        Params['channel'] = ichannel
        Params['time_period'] = timePeriodValue
        #uri = "http://www.oreillynet.com/meerkat/xml-rpc/server.php"
        #meerkatsvr = xmlrpclib.Server(uri)
        #print '(Meerkat.items) Params: %s' % str(Params)
        items = meerkatServer.meerkat.getItems(Params)
        return (title, items)


