# Make this directory a package.

_q_exports = ['soap_source', 'test2_dir']


import time
from quixote.util import StaticFile, StaticDirectory
from servicesui import MenuUI, InfoUI, ServicesUI, MeerkatUI


def _q_lookup(request, name):
    # Test: Stall long enough so that we can make several requests and force the creation
    #   of more than one child process.
##    time.sleep(10)
    if name == 'info':
##        print '(_q_lookup) handling info -- name: %s' % name
        handler = InfoHandler()
        return handler
    elif name == 'service':
##        print '(_q_lookup) handling service -- name: %s' % name
        handler = ServiceHandler()
        return handler
    elif name == 'meerkat':
##        print '(_q_lookup) handling meerkat -- name: %s' % name
        handler = MeerkatHandler()
        return handler
    else:
##        print '(_q_lookup) creating menu -- name: %s' % name
        menu = MenuUI()
        return menu.index(request)

class InfoHandler:
    _q_exports = ['requestinfo', 'serverinfo']
    def requestinfo(self, request):
        info = InfoUI()
        content = info.do_requestinfo(request)
##        print '(InfoHandler.requestinfo) type(content):', type(content)
##        print '(InfoHandler.requestinfo) content:', content
        return content
    def serverinfo(self, request):
        info = InfoUI()
        content = info.do_serverinfo(request)
##        print '(InfoHandler.serverinfo) type(content):', type(content)
##        print '(InfoHandler.serverinfo) content:', content
        return content
    def _q_index(self, request):
        menu = MenuUI()
        return menu.index(request)


class ServiceHandler:
    _q_exports = []
    def _q_lookup(self, request, name):
##        print '(ServiceHandler._q_lookup) name: %s' % name
        services = ServicesUI()
        meth = getattr(services, 'do_' + name, None)
        if meth:
            return meth(request)
        else:
            menu = MenuUI()
            return menu.index(request)


class MeerkatHandler:
    _q_exports = []
    def _q_lookup(self, request, name):
##        print '(ServiceHandler._q_lookup) name: %s' % name
        meerkat = MeerkatUI()
        meth = getattr(meerkat, 'do_' + name, None)
        if meth:
            return meth(request)
        elif name == 'items':
            return meerkat
        else:
            menu = MenuUI()
            return menu.index(request)


soap_source = StaticFile(
    "/w1/Python/Quixote/test2/soapserver.py",
    follow_symlinks=1,
    mime_type="text/plain"
    )

#
# Notes: 
# - In order for StaticDirectory to work, there must be a slash on the
#   end of the URI.
# - Without the list_directory=1 argument, the files in the directory
#   are available, but the directory is not shown.
#
test2_dir = StaticDirectory("/w1/Python/Quixote/test2", list_directory=1)

